function y = mtimes(L, x)

vec_flag=0;
if size(x,2)==1
    if L.transpose==0
        x=reshape(x,L.n,L.m,3);
    else
        x=reshape(x,2*L.n,L.m,3);
    end
    vec_flag=1;
end


n=L.n;
m=L.m;
if L.transpose==0
    y=zeros(2*n,m,3);
    % Red
    xhat=fft2(x(:,:,1));
    y(1:n,:,1)=real(ifft2(L.L1.*xhat));
    y(n+1:end,:,1)=real(ifft2(L.L2.*xhat));
    % Green
    xhat=fft2(x(:,:,2));
    y(1:n,:,2)=real(ifft2(L.L1.*xhat));
    y(n+1:end,:,2)=real(ifft2(L.L2.*xhat));
    % Blue
    xhat=fft2(x(:,:,3));
    y(1:n,:,3)=real(ifft2(L.L1.*xhat));
    y(n+1:end,:,3)=real(ifft2(L.L2.*xhat));
else
    y=zeros(n,m,3);
    % Red
    xhat1=fft2(x(1:n,:,1));
    xhat2=fft2(x(n+1:end,:,1));
    y(:,:,1)=real(ifft2(conj(L.L1).*xhat1+conj(L.L2).*xhat2));
    % Red
    xhat1=fft2(x(1:n,:,2));
    xhat2=fft2(x(n+1:end,:,2));
    y(:,:,2)=real(ifft2(conj(L.L1).*xhat1+conj(L.L2).*xhat2));
    % Blue
    xhat1=fft2(x(1:n,:,3));
    xhat2=fft2(x(n+1:end,:,3));
    y(:,:,3)=real(ifft2(conj(L.L1).*xhat1+conj(L.L2).*xhat2));
end

if vec_flag==1
    y=y(:);
end
end
